﻿using UnityEngine;
using System.Collections;

public class Player : MonoBehaviour
{
    private Animator anim;
    public Animator characterAnimator;
    public Transform handBone;
    public Transform ball;
    public Vector3 positionAdjust = new Vector3();
    private bool shooting = false;
    private int idleParam = Animator.StringToHash("Idle");
    public float minY;

	void Start ()
	{
        anim = GetComponent<Animator>();
	}
	
	
	void Update ()
	{
	    Vector3 bpos = handBone.position + positionAdjust;
	    if (bpos.y < minY)
	        bpos.y = minY;
	    ball.position = bpos;

	    if (shooting)
	    {
            characterAnimator.SetBool("Shoot", false);
	        shooting = false;
	    } else if (!shooting)
	    {
            if (Input.GetKeyDown(KeyCode.Space))
            {
                Shoot();
            }
	        if (Input.touchCount > 0)
	        {
	            if (!shooting)
	            {
                    Touch t = Input.touches[0];
                    Shoot();

               }
            }
        }
    }

    public void Shoot()
    {
        if (shooting)
            return;

        shooting = true;
        characterAnimator.SetBool("Shoot", true);
    }
}
