﻿using UnityEngine;
using System.Collections;

public class AnimatePosition : MonoBehaviour {

	public Vector3 minPosition = new Vector3();
	public Vector3 maxPosition = new Vector3();

	[Range(0.0f, 50.0f)]
	public float lerpTime = 1.0f;

	[Range(0.0f, 50.0f)]
	public float positionTime = 1.0f;

	private float cpTime = 1.0f;

	private float posTime = -1;
	private Vector3 startPos;

	private Vector3 npos;

	void Start () {
		startPos = transform.position;
		posTime = Time.time;
		cpTime = positionTime;
		npos = startPos;
	}
	

	void Update () {
		float ct = Time.time - posTime;
		if (ct > cpTime) {
			cpTime = positionTime;
			posTime = Time.time;
			npos = new Vector3(startPos.x + Random.Range(minPosition.x, maxPosition.x), startPos.y + Random.Range(minPosition.y, maxPosition.y), startPos.z + Random.Range(minPosition.z, maxPosition.z));
		}

		transform.position = Vector3.Lerp(transform.position, npos, Time.deltaTime * lerpTime);
	}
}
