﻿using UnityEngine;
using System.Collections;

[RequireComponent(typeof(Animator))]
//[ExecuteInEditMode]
public class AnimationControllerTools : MonoBehaviour {

	private Animator anim;
    private int stateHash;
    

	public bool playing = true;
	private bool prevPlaying = true;

	private float prevSpeed = 0;

    public bool controlPosition = false;

    [Range(0.0f, 1.0f)] [SerializeField] 
    public float animationPosition;

	void Start () {
		anim = GetComponent<Animator>();
	    stateHash = anim.GetCurrentAnimatorStateInfo(0).nameHash;
		//Debug.Log (stateHash);

	}
	
	void Update () {


		if (playing != prevPlaying) {
			prevPlaying = playing;

			if (playing) {
				anim.speed = prevSpeed;
				anim.Play(stateHash, 0, animationPosition);
			} else {
				prevSpeed = anim.speed;
				anim.speed = 0;
			    animationPosition = anim.GetCurrentAnimatorStateInfo(0).normalizedTime;
				anim.StopPlayback();
			}
		}
	    if (!playing)
	    {
			if (animationPosition >= 1)
			{
				anim.Play(stateHash, 0, 0.9999999f);			
			} else {
	        	anim.Play(stateHash, 0, animationPosition);
			}
	    }
	}
}
