﻿using System;

namespace Unity.PerForm.Utils
{
    public sealed class Null
    {
        public static bool ToBool(object val, bool defVal)
        {
            if (IsNull(val))
                return defVal;

            return Convert.ToBoolean(val);
        }

        public static int ToInt(object val)
        {
            if (IsNull(val))
                return 0;

            return Convert.ToInt32(val);
        }

        public static bool IsNull(object val)
        {
            if (val == null)
                return true;
            if (val == DBNull.Value)
                return true;

            return false;
        }

        public static DateTime ToDateTime(object val, DateTime defaultValue)
        {
            if (IsNull(val))
                return defaultValue;

            return (DateTime)val;
        }

        public static string ToString(object val, string defaultValue)
        {
            if (IsNull(val))
                return defaultValue;

            return val.ToString();
        }
    }

}
